dbReports/iondb/product_integration/urls.py
# Copyright (C) 2017 Ion Torrent Systems, Inc. All Rights Reserved
from django.conf.urls import patterns, url, include
from tastypie.api import Api

from iondb.product_integration import api

v1_api = Api(api_name='v1')
v1_api.register(api.DeepLaserResponseResource())

urlpatterns = patterns(
    'iondb.product_integration',
    url(r'^tfc/configure/$', 'views.configure', name="tfc_configure"),
    url(r'^tfc/configure/(?P<pk>\d+)/delete$', 'views.delete', name="tfc_delete"),
    url(r'^api/', include(v1_api.urls)),
)

dbReports/iondb/rundb/urls.py
# Copyright (C) 2010 Ion Torrent Systems, Inc. All Rights Reserved
try:
    from django.conf.urls import patterns, url, include
except ImportError:
    # Compat Django 1.4
    from django.conf.urls.defaults import patterns, url, include


from tastypie.api import Api

from iondb.rundb import api
from iondb.rundb import mesh_api

v1_api = Api(api_name='v1')
v1_api.register(api.GlobalConfigResource())
v1_api.register(api.ExperimentResource())
v1_api.register(api.ResultsResource())
v1_api.register(api.ReferenceGenomeResource())
v1_api.register(api.ObsoleteReferenceGenomeResource())
v1_api.register(api.LocationResource())
v1_api.register(api.RigResource())
v1_api.register(api.PluginResource())
v1_api.register(api.PluginResultResource())
v1_api.register(api.PluginResultJobResource())
v1_api.register(api.FileServerResource())
v1_api.register(api.TFMetricsResource())
v1_api.register(api.LibMetricsResource())
v1_api.register(api.AnalysisMetricsResource())
v1_api.register(api.QualityMetricsResource())
v1_api.register(api.RunTypeResource())
v1_api.register(api.dnaBarcodeResource())
v1_api.register(api.PlannedExperimentDbResource())
v1_api.register(api.PlannedExperimentResource())
v1_api.register(api.PublisherResource())
v1_api.register(api.ContentResource())
v1_api.register(api.ContentUploadResource())
v1_api.register(api.UserEventLogResource())

v1_api.register(api.KitInfoResource())
v1_api.register(api.KitPartResource())
v1_api.register(api.SequencingKitInfoResource())
v1_api.register(api.SequencingKitPartResource())
v1_api.register(api.ActiveSequencingKitInfoResource())
v1_api.register(api.ActivePGMSequencingKitInfoResource())
v1_api.register(api.ActiveProtonSequencingKitInfoResource())
v1_api.register(api.LibraryKitInfoResource())
v1_api.register(api.LibraryKitPartResource())
v1_api.register(api.ActiveLibraryKitInfoResource())
v1_api.register(api.ActivePGMLibraryKitInfoResource())
v1_api.register(api.ActiveProtonLibraryKitInfoResource())
v1_api.register(api.LibraryKeyResource())
v1_api.register(api.ThreePrimeadapterResource())
v1_api.register(api.TemplateResource())

v1_api.register(api.MessageResource())
v1_api.register(api.MonitorDataResource())

v1_api.register(api.TorrentSuite())
v1_api.register(api.NetworkResource())
v1_api.register(api.IonReporter())

v1_api.register(api.ProjectResource())
v1_api.register(api.ProjectResultsResource())
v1_api.register(api.UserResource())

v1_api.register(api.CompositeResultResource())
v1_api.register(api.CompositeExperimentResource())
v1_api.register(api.MonitorResultResource())

v1_api.register(api.ApplProductResource())
v1_api.register(api.QCTypeResource())
v1_api.register(api.PlannedExperimentQCResource())
v1_api.register(api.EventLogResource())
v1_api.register(api.EmailAddressResource())

v1_api.register(api.ChipResource())

v1_api.register(api.AccountResource())

v1_api.register(api.SampleResource())
v1_api.register(api.ExperimentAnalysisSettingsResource())
v1_api.register(api.CompositeDataManagementResource())
v1_api.register(api.DataManagementHistoryResource())
v1_api.register(api.ClusterInfoHistoryResource())

v1_api.register(api.IonChefPrepKitInfoResource())
v1_api.register(api.ActiveIonChefPrepKitInfoResource())
v1_api.register(api.ActiveIonChefLibraryPrepKitInfoResource())

v1_api.register(api.AvailableIonChefPlannedExperimentResource())
v1_api.register(api.AvailableIonChefPlannedExperimentSummaryResource())
v1_api.register(api.IonChefPlanTemplateResource())
v1_api.register(api.IonChefPlanTemplateSummaryResource())
v1_api.register(api.GetChefScriptInfoResource())

v1_api.register(api.AvailableOneTouchPlannedExperimentResource())
v1_api.register(api.AvailableOneTouchPlannedExperimentSummaryResource())
v1_api.register(api.OneTouchPlanTemplateResource())
v1_api.register(api.OneTouchPlanTemplateSummaryResource())

v1_api.register(api.AvailablePlannedExperimentSummaryResource())
v1_api.register(api.PlanTemplateSummaryResource())
v1_api.register(api.PlanTemplateBasicInfoResource())

v1_api.register(api.ApplicationGroupResource())
v1_api.register(api.SampleGroupType_CVResource())
v1_api.register(api.SampleAnnotation_CVResource())

v1_api.register(api.SampleSetResource())
v1_api.register(api.SampleSetItemResource())
v1_api.register(api.SampleSetItemInfoResource())

v1_api.register(api.SampleAttributeResource())
v1_api.register(api.SampleAttributeDataTypeResource())

v1_api.register(api.SamplePrepDataResource())

v1_api.register(api.AnalysisArgsResource())
v1_api.register(api.FlowOrderResource())
v1_api.register(api.common_CVResource())

v1_api.register(api.FileMonitorResource())
v1_api.register(api.SupportUploadResource())
v1_api.register(api.GetChefCartridgeUsageResource())


v1_api.register(api.PrepopulatedPlanningSessionResource())
v1_api.register(api.IonMeshNodeResource())

v1_mesh_api = Api(api_name='v1')
v1_mesh_api.register(mesh_api.MeshCompositeExperimentResource())
v1_mesh_api.register(mesh_api.MeshPrefetchResource())
v1_mesh_api.register(mesh_api.AutoDiscoveredHostsResource())

urlpatterns = patterns(
    'iondb.rundb',
    url(r'^$', 'data.views.rundb_redirect'),
    url(r'^metaDataLog/(?P<pkR>.*)/$', 'views.viewLog', name="report_metadata_log"),
    (r'^getCSV.csv$', 'views.getCSV'),
    (r'^getPDF/(?P<pkR>.*)/$', 'views.PDFGen'),
    (r'^getOldPDF/(?P<pkR>.*)/$', 'views.PDFGenOld'),
    (r'^tfcsv/$', 'views.tf_csv'),
    (r'^getPDF/(?P<pkR>.*)/$', 'views.PDFGen'),

    (r'^islive/(\d+)$', 'ajax.analysis_liveness'),
    (r'^star/(\d+)/(\d)$', 'ajax.starRun'),
    (r'^progress_bar/(\d+)$', 'ajax.progress_bar'),
    (r'^api$', 'ajax.apibase'),
    (r'^changelibrary/(\d+)$', 'ajax.change_library'),
    (r'^reports/progressbox/(\d+)$', 'ajax.progressbox'),

    (r'^report/(\d+)$', 'views.displayReport'),
    (r'^graphiframe/(\d+)/$', 'report.classic.graph_iframe'),

    (r'^publish/api/(?P<pub_name>\w+)$', 'publishers.publisher_api_upload'),  #REFACTOR: move to rundb/configure
    (r'^publish/plupload/(?P<pub_name>\w+)/$', 'publishers.write_plupload'),  #REFACTOR: move to rundb/configure
    (r'^publish/(\w+)$', 'publishers.publisher_upload'),  #REFACTOR: move to rundb/configure
    (r'^published/$', 'publishers.list_content'),  #REFACTOR: move to rundb/configure
    (r'^uploadstatus/(\d+)/$', 'publishers.upload_status'),  #REFACTOR: move to rundb/configure
    (r'^uploadstatus/frame/(\d+)/$', 'publishers.upload_status', {"frame": True}),  #REFACTOR: move to rundb/configure
    (r'^uploadstatus/download/(\d+)/$', 'publishers.upload_download'),  #REFACTOR: move to rundb/configure
    (r'^content/download/(\d+)/$', 'publishers.content_download'),  #REFACTOR: move to rundb/configure
    (r'^content/targetregions/add/$', 'publishers.content_add', {'hotspot': False}),  #REFACTOR: move to rundb/configure
    (r'^content/hotspots/add/$', 'publishers.content_add', {'hotspot': True}),  #REFACTOR: move to rundb/configure

    (r'^updateruninfo/$', 'views.updateruninfo'),

    (r'^demo_consumer/?(?P<name>\w+)', 'events.demo_consumer'),

    )

urlpatterns.extend(patterns(
            '',
            (r'^api/', include(v1_api.urls)),
            (r'^api/mesh/', include(v1_mesh_api.urls)),
))

dbReports/iondb/security/urls.py
# Copyright (C) 2010 Ion Torrent Systems, Inc. All Rights Reserved
from django.conf.urls import patterns, include
from tastypie.api import Api
from iondb.security import api

v1_api = Api(api_name='v1')
v1_api.register(api.SecureStringResource())

urlpatterns = patterns('iondb.security', (r'^api/', include(v1_api.urls)))

dbReports/iondb/urls.py
# Copyright (C) 2010 Ion Torrent Systems, Inc. All Rights Reserved

from django.conf import settings
try:
    from django.conf.urls import patterns, url, include
except ImportError:
    # Compat Django 1.4
    from django.conf.urls.defaults import patterns, url, include

from django.contrib.staticfiles.urls import staticfiles_urlpatterns


# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()
# admin.site.login_template = "rundb/login.html"

from iondb.rundb.login.urls import urlpatterns as login_patterns
from iondb.servelocation import serve_wsgi_location
from iondb.utils.utils import is_TsVm

urlpatterns = patterns(
    r'',
    (r'^product_integration/', include('iondb.product_integration.urls')),
    (r'^configure/', include('iondb.rundb.configure.urls')),
    (r'^data/', include('iondb.rundb.data.urls')),
    (r'^monitor/', include('iondb.rundb.monitor.urls')),
    (r'^plan/', include('iondb.rundb.plan.urls')),
    (r'^sample/', include('iondb.rundb.sample.urls')),
    (r'^report/', include('iondb.rundb.report.urls')),
    (r'^rundb/', include('iondb.rundb.urls')),
    (r'^security/', include('iondb.security.urls')),
    (r'^home/', include('iondb.rundb.home.urls')),

    # Admin
    (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    (r'^admin/manage/$', 'iondb.rundb.admin.manage'),
    (r'^admin/network/$', 'iondb.rundb.admin.network'),
    (r'^admin/network/check$', 'iondb.rundb.admin.how_am_i'),
    (r'^admin/network/external_ip/$', 'iondb.rundb.admin.fetch_remote_content', {"url": settings.EXTERNAL_IP_URL}),
    (r'^admin/network/how_is/(?P<host>[\w\.]+):(?P<port>\d+)/feeling$', 'iondb.rundb.admin.how_are_you'),
    (r'^admin/update/$', 'iondb.rundb.admin.update'),
    (r'^admin/update/check/$', 'iondb.rundb.admin.run_update_check'),
    (r'^admin/update/tsconfig_log/$', 'iondb.rundb.admin.tsconfig_log'),
    (r'^admin/update/download_logs/$', 'iondb.rundb.admin.get_zip_logs'),
    (r'^admin/updateOneTouch/$', 'iondb.rundb.admin.updateOneTouch'),
    (r'^admin/updateOneTouch/ot_log$', 'iondb.rundb.admin.ot_log'),
    (r'^admin/update/install_log$', 'iondb.rundb.admin.install_log'),
    (r'^admin/update/install_lock$', 'iondb.rundb.admin.install_lock'),
    (r'^admin/update/version_lock/(?P<enable>[\w\.]+)', 'iondb.rundb.admin.version_lock'),
    (r'^admin/update/maintenance/(?P<action>[\w\.]+)', 'iondb.rundb.admin.maintenance'),
    (r'^admin/experiment/exp_redo_from_scratch/$', 'iondb.rundb.admin.exp_redo_from_scratch'),
    url(r'^admin/configure_server/$', 'iondb.rundb.admin.configure_server', name="configure_server"),
    url(r'^admin/tsvm/$', 'iondb.rundb.admin.tsvm_control', name="tsvm"),
    url(r'^admin/tsvm/(?P<action>\w+)/$', 'iondb.rundb.admin.tsvm_control', name="tsvm"),
    url(r'^admin/tsvm_log/(.+)/$', 'iondb.rundb.admin.tsvm_get_log', name="tsvm_log"),

    # password change doesn't accept extra_context
    (r'^admin/password_change/done/', admin.site.password_change_done),
    (r'^admin/password_change/', admin.site.password_change),
    (r'^admin/logout/', admin.site.logout),
    (r'^admin/$', admin.site.index, {'extra_context': {'is_VM': is_TsVm() }}),
    (r'^admin/(?P<app_label>\w+)/$', admin.site.app_index, {'extra_context': {'is_VM': is_TsVm() }}),
    (r'^admin/', include(admin.site.urls)),

    (r'^(?P<urlpath>output.*)$', serve_wsgi_location),
    (r'^(?P<urlpath>chef_logs.*)$', serve_wsgi_location),
    (r'^(?P<urlpath>ot_logs.*)$', serve_wsgi_location),
)
urlpatterns.extend(login_patterns)
urlpatterns.extend(staticfiles_urlpatterns())

if settings.TEST_INSTALL:
    from os import path
    urlpatterns.extend(patterns(
        '',
        (r'^site_media/(?P<path>.*)$',
         'django.views.static.serve',
         {'document_root': settings.MEDIA_ROOT}),
        (r'^testreports/(?P<path>.*)$',
         'django.views.static.serve',
         {'document_root': path.join(path.dirname(settings.MEDIA_ROOT),
                                     "testreports")})))

dbReports/iondb/security/models.py
# Copyright (C) 2017 Ion Torrent Systems, Inc. All Rights Reserved
"""
NOTE: The GPG algorithm is sensitive to the encoding so if the strings are encoded in something
different than what the django locale's preferred encoding then it will fail to decrypt
"""

from django.db import models
from django.utils.functional import cached_property
import gnupg

HOME = '/tmp'


class SecureString(models.Model):
    """Used for storing information securely"""

    # storage for the encrypted password
    # NEVER NEVER ASSIGN THIS FIELD MANUALLY!!!!!!!!!!!!!!
    encrypted_string = models.CharField(null=False, max_length=1000)

    # the date/time this was created
    created = models.DateTimeField(auto_now_add=True)

    # the name and natural key of the entry
    name = models.CharField(max_length=128, unique=True, null=False)

    @classmethod
    def get_secure_key(cls):
        # read the super secret key from the file system
        with open('/var/spool/ion/key') as key_fp:
            key = key_fp.read().strip()
            return key

    @classmethod
    def create(cls, unencrypted, name):
        gpg = gnupg.GPG(gnupghome=HOME)
        ep = gpg.encrypt(data=str(unencrypted), recipients=None, symmetric='AES256', passphrase=cls.get_secure_key())
        if not ep:
            raise Exception("Failed to encrypt the data.")

        return cls(name=name, encrypted_string=ep.data.strip())

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        """Override the save method to make sure the string is correctly encrypted before saving"""

        if not self.encrypted_string:
            raise Exception("Cannot save an empty string for " + self.name)

        if not self.encrypted_string.startswith('-----BEGIN PGP MESSAGE-----'):
            raise Exception("This is not a pgp encrypted string.")

        super(SecureString, self).save(*args, **kwargs)

    def natural_key(self):
        """Get the natural key for this entry"""
        return self.name

    def encrypt(self, unencrypted):
        """Used to update the encrypted string"""
        gpg = gnupg.GPG(gnupghome=HOME)
        ep = gpg.encrypt(data=str(unencrypted), recipients=None, symmetric='AES256', passphrase=self.get_secure_key())
        if not ep:
            raise Exception("Failed to encrypt the data.")
        self.encrypted_string = ep.data.strip()

    @cached_property
    def decrypted(self):
        """This will decrypt a encrypted message and make sure the unencrypted string never hits the disk"""
        return str(gnupg.GPG(gnupghome=HOME).decrypt(self.encrypted_string, passphrase=self.get_secure_key()))

dbReports/iondb/product_integration/forms.py
# Copyright (C) 2017 Ion Torrent Systems, Inc. All Rights Reserved
from django import forms


class ThermoFisherCloudConfigForm(forms.Form):
    """Form for associating an thermo fisher cloud account with the user"""

    tfc_username = forms.CharField(max_length=128, label="Username/Email")
    tfc_password = forms.CharField(widget=forms.PasswordInput(), label="Password", required=False)

dbReports/iondb/rundb/login/forms.py
# Copyright (C) 2012 Ion Torrent Systems, Inc. All Rights Reserved

from django import forms
from iondb.rundb import models
from django.contrib.auth.forms import AuthenticationForm
from django.utils.translation import ugettext_lazy as _


class UserRegistrationForm(forms.Form):
    """
    Form for registering a new user account.

    Validates that the requested username is not already in use, and
    requires the password to be entered twice to catch typos.

    """
    username = forms.RegexField(
        regex=r'^[\w.@+-]+$',
        max_length=30,
        widget=forms.TextInput(),
        label="Username",
        error_messages={'invalid':
            "This value may contain only letters, numbers and @/./+/-/_ characters."})

    email = forms.EmailField(widget=forms.TextInput(attrs={'maxlength':75}),
                             label="E-mail")
    password1 = forms.CharField(widget=forms.PasswordInput(render_value=False),
                                label="Password")
    password2 = forms.CharField(widget=forms.PasswordInput(render_value=False),
                                label="Password (again)")

    def clean_username(self):
        """
        Validate that the username is alphanumeric and is not already
        in use.
        """
        existing = models.User.objects.filter(username__iexact=self.cleaned_data['username'])
        if existing.exists():
            raise forms.ValidationError("A user with that username already exists.")
        else:
            return self.cleaned_data['username']

    def clean(self):
        """
        Verify that the values entered into the two password fields
        match. Note that an error here will end up in
        ``non_field_errors()`` because it doesn't apply to a single
        field.
        """
        if 'password1' in self.cleaned_data and 'password2' in self.cleaned_data:
            if self.cleaned_data['password1'] != self.cleaned_data['password2']:
                raise forms.ValidationError("The two password fields didn't match.")
        return self.cleaned_data


class AuthenticationRememberMeForm(AuthenticationForm):

    """
    Subclass of Django ``AuthenticationForm`` which adds a remember me
    checkbox.
    
    """
    
    remember_me = forms.BooleanField(label=_('Remember Me'), initial=False,
        required=False)

dbReports/iondb/templates/rundb/login/index.html
{% load url from future %}
{% load static from staticfiles %}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Torrent Browser | Thermo Fisher Scientific</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" media="all" href="{% static "resources/bootstrap/css/bootstrap.min.css"%}" />
    <link rel="stylesheet" href="{% static "resources/bootstrap/css/bootstrap-responsive.min.css"%}" >
    <script type="text/javascript">
    if (!window.console) {
        (function() {
          var names = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
          "group", "groupEnd", "time", "timeEnd", "count", "trace", "profile", "profileEnd"];
              window.console = {};
              for (var i = 0; i < names.length; ++i) {
                window.console[names[i]] = function() {};
              }
            }());
    }
    </script>
    <!--Generate the Torrent Browser CSS using less js-->

    <link type="text/css" rel="stylesheet" href="{% static "resources/styles/tb-layout.min.css"%}" />
    <script type="text/javascript" src="{% static "resources/less/less-1.3.0.min.js"%}"></script>
    <link type="text/css" rel="stylesheet" href="{% static "resources/styles/tb-styles.min.css"%}" />

    <script type="text/javascript" src="{% static "resources/jquery/jquery-1.8.2.min.js"%}"></script>
    <script type="text/javascript" src="{% static "resources/jquery/jquery.cookie.js"%}"></script>
    <script type="text/javascript" src="{% static "resources/jquery-ui-1.9.2.custom/js/jquery-ui-1.9.2.custom.min.js"%}"></script>
    <script type="text/javascript" src="{% static "resources/bootstrap/js/bootstrap.min.js"%}"></script>
    <script type="text/javascript" src="{% static "resources/scripts/tb.min.js"%}"></script>
    <style>
        body {
            background: white;
        }
        #logo {
            margin-top: 23px;
        }
        #login-pane {
            padding-top: 100px;
        }
        #login-pane > #site-name {
            margin-top: 0;
            color: white;
        }
        .jumbo-brand-block {
            height: 589px;
            width: 100%;
            background-color: black;
            background-image: url('/site_media/img/hero-background.jpg');
            background-repeat: no-repeat;
            background-position: center top;
        }
        #squares {
            padding-top: 20px;
            text-align: center;
        }
        #footer {
            padding-top: 100px;
            color: #A9A9A9;
        }
        #login_html {
            margin-top: 20px;
            color: #fff;
        }
        .workflow-btn {
            background: transparent;
            position:absolute;
            width:66px;
            height:79px;
            overflow: hidden;
        }
        .workflow-btn:hover {
            background: transparent;
            bottom: 0;
        }
        #workflow_report:hover {
            background-image: url('{% static "img/link-report-hover.png" %}');
        }
        #workflow_design:hover {
            background-image: url('{% static "img/link-design-hover.png" %}');
        }

    </style>
</head>
<body>
    <div class="login">
        <div class="container">
            <noscript>
                <style type="text/css">
                    .login-form {
                        display:none;
                        min-height: 100px;
                    }
                    .splash-workflow{
                        display:none;
                        height: 0px;
                    }
                    .alert{
                        margin-top: 100px;
                    }
                </style>
                <div class="noscriptmsg">
                    <div class="alert alert-block">
                        <h1>Warning!</h1>
                        <h3>The Torrent Browser requires JavaScript. Please ensure that your browser has JavaScript enabled.</h3>
                    </div>
                </div>
            </noscript>
            <div class="row">
                <div class="span12">
                    <img id="logo" class="pull-left" src="{% static "img/iontorrent_logo.png"%}" alt="Ion Torrent: Sequencing for all"/>
                    <div id="workflow" class="pull-right" style="position: relative; display: inline-block;">
                        <img id="workflowBar" class="pull-right" src="{% static "img/workflow-header-bar-thing.png" %}" alt="Informatics workflow"/>
                        <a id="workflow_design" href="https://www.ampliseq.com/" class="btn workflow-btn" style="left: 92px;"></a>
                        <a id="workflow_report" href="https://ionreporter.lifetechnologies.com/" class="btn workflow-btn" style="right: 0px;"></a>
                    </div>
                </div>
            </div>
        </div>
        <div class="jumbo-brand-block">
            <div class="container">
                <div class="row">
                    <div id="login-pane" class="span4">
                        {% if base_site_name.strip != "" %}
                            <h1 id="site-name">{{ base_site_name }}</h1>
                        {% endif %}
                        <img style="margin: 100px 0; margin-bottom: 20px" src="{% static "img/torrent-browser-wordmark.png" %}" alt="Torrent Browser"/>
                        <div id="login_html" class="clearfix">
                            {% include "rundb/login/login.html" %}
                        </div>
                    </div>
                    <div id="squares" class="span8">
                        <img src="{% static "img/four-info-rectangles.png" %}" alt="Plan Monitor Review Export"/>
                    </div>
                </div>
            </div>
        </div>
        <div id="footer" class="container">
            <div class="row">
                <div class="span12">
                    <p>For Research Use Only. Not for use in diagnostic procedures.</p>
                    <p class="copyright">&copy; 2018 Thermo Fisher Scientific Inc. All Rights Reserved.</p>
                </div>
            </div>
        </div>
    </div>
<script type="text/javascript">
$(document).ready(function(){
    submitHandler = function(e) {
        e.preventDefault();
        url = $(this).attr('action');
        u = $(this).find('#id_username').val();
        p = $(this).find('#id_password').val();
        var jqxhr = $.post(url, $(this).serializeArray(), function(data,status,xhr) {
            console.log("success");
        })
        .success(function(data,status,xhr) {
            if(data.redirect) {
                window.location.href = data.redirect;
            } else {
                $('#login_html').empty();
                $('#login_html').append(data.form);
                $('#login-form').submit(submitHandler);
            }
            console.log("second success");
        })
        .error(function(data,status,xhr) { 
            console.log("error"); 
        }).complete(function(data,status,xhr) { 
            console.log("complete"); 
        });
        
    };
    $('#login-form').submit(submitHandler);
});
</script>
</body>
</html>

dbReports/iondb/templates/rundb/login/ion_account_reg.html
{% extends "rundb/common/base.html" %}

{% block content %}

<h3>New User Registration</h3>
{% for error in form.errors %}
<p>{{ error }}</p>
{% endfor %}

<form method="post" action="">
{% csrf_token %}
{{ form.as_p }}
<input type="submit" value="Submit"/>
</form>

{% endblock content %}

dbReports/iondb/templates/rundb/login/login.html
{% load url from future %}
{% if user.is_authenticated %}
<p style="text-align: right;">
    Welcome {{ user.get_full_name|default:user.username }}!
    <a id="begin_button" class="btn btn-primary" href="{% if next %}{{next|escape}}{% elif request.GET.next %}{{request.GET.next|escape}}{% else %}{% url 'data' %}{% endif %}">Begin</a>
</p>
<p style="margin-top: 20px; color: #d3d3d3;">
        Not {{ user.get_full_name|default:user.username }}?
        <a id="signout" href="{% url 'logout' %}">Login as another user</a>
</p>

{% else %}
    <div style="min-height: 56px">
        {% if form.errors %}
            <p class="alert alert-error" style="margin-bottom: 0px">Your username and password didn't match. Please try
                again.</p>
        {% endif %}
    </div>
<form id="login-form" class="form" action="{% url 'login_ajax' %}" method="POST" style="margin-top: 10px">
    {% csrf_token %}
    <input type="text" id="id_username" name="username" placeholder="User name" class="span3" tabindex="1">
    <input type="password" id="id_password" name="password" placeholder="Password" class="span3" tabindex="2">
    <div style="width: 256px">
        <button type="submit" class="btn btn-primary" tabindex="4">Sign In</button>
        <label for="id_remember_me" class="checkbox pull-right" style="margin-top: 4px">Remember Me<input id="id_remember_me" type="checkbox" name="remember_me" class="checkbox" checked="checked" tabindex="3"></label>
    </div>
    <div class="help-block" style="margin-top: 100px;"><a href="{% url 'signup' %}" class="btn btn-small">Register</a> for a new account</div>
    <input type="hidden" id="next" name="next"
        value="{% filter force_escape %}{% firstof next request.GET.next request.META.REDIRECT_URL request.META.HTTP_REFERER %}{% endfilter %}">
</form>
{% endif %}
<script type="text/javascript">
    $('div.splash-workflow div').off();
    $('div.splash-workflow div').click(function(){
        $(this).parent().children().removeClass('active');
        $(this).addClass('active');
        $('#begin_button').attr('href', $(this).data('href'));
        $('#next').attr('value', $(this).data('href'));
    });
</script>

dbReports/iondb/templates/rundb/login/pending.html
{% extends "rundb/common/base.html" %}
{% block content %}

<h3>Thanks for Registering</h3>
<p>Your account has been created and is pending approval by an admin user.</p>
<p>Please contact your local admin and ask them to visit
   the Account Configuration page to activate your new account.</p>

{% endblock content %}